<?php

/**
 * Class ControllerExtensionPaymentZondacryptopay
 */
class ControllerExtensionPaymentZondacryptopay extends Controller
{

	private $error = [];

	/**
	 * View admin panel.
	 */
	public function index()
	{
		$this->language->load('extension/payment/zondacryptopay');
		$this->document->setTitle($this->language->get('text_heading_title'));
		$this->load->model('setting/setting');

		$request = $this->request->post;

		if(($this->request->server['REQUEST_METHOD'] == 'POST')
			&& $this->validate()
		) {

			$settings = array_merge($this->model_setting_setting->getSetting('payment_zondacryptopay'), $request);
			$this->model_setting_setting->editSetting('payment_zondacryptopay', $settings);
			$this->session->data['success'] = $this->language->get('text_success');
			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));

			return;
		}

		include_once(DIR_SYSTEM . 'library/payment-core/vendor/autoload.php');

		$base_url = $this->config->get('config_url');

		if(isset($this->request->server['HTTPS']) && (($this->request->server['HTTPS'] == 'on') || ($this->request->server['HTTPS'] == '1'))) {
			$base_url = $this->config->get('config_ssl');
		}

		$data = [
			'zondacryptopay_status' => isset($this->request->post['payment_zondacryptopay_status'])
				? $this->request->post['payment_zondacryptopay_status']
				: $this->config->get('payment_zondacryptopay_status'),

			'zondacryptopay_private_key' => isset($this->request->post['payment_zondacryptopay_private_key'])
				? $this->request->post['payment_zondacryptopay_private_key']
				: $this->config->get('payment_zondacryptopay_private_key'),

			'zondacryptopay_public_key' => isset($this->request->post['payment_zondacryptopay_public_key'])
				? $this->request->post['payment_zondacryptopay_public_key']
				: $this->config->get('payment_zondacryptopay_public_key'),

			'zondacryptopay_sort_order' => isset($this->request->post['payment_zondacryptopay_sort_order'])
				? $this->request->post['payment_zondacryptopay_sort_order']
				: $this->config->get('payment_zondacryptopay_sort_order'),

			'zondacryptopay_payment_title_default' => $this->language->get('text_zondacryptopay_payment_title_default'),
			'zondacryptopay_payment_title'         => isset($this->request->post['payment_zondacryptopay_payment_title'])
				? $this->request->post['payment_zondacryptopay_sort_order']
				: $this->config->get('payment_zondacryptopay_payment_title'),

			'error_validation' => $this->error,

			'notification_url' => $base_url . 'index.php?route=extension/payment/zondacryptopay/notification',

			'confirm_url' => $this->url->link('extension/payment/zondacryptopay', 'user_token=' . $this->session->data['user_token'], true),
			'cancel_url'  => $this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'], true),

			'content_footer'      => $this->load->controller('common/footer'),
			'content_header'      => $this->load->controller('common/header'),
			'content_column_left' => $this->load->controller('common/column_left'),
			'heading_title'       => $this->language->get('text_heading_title'),

			'breadcrumbs' => [
				[
					'text'      => $this->language->get('text_home'),
					'href'      => $this->url->link('common/home', 'user_token=' . $this->session->data['user_token'], 'SSL'),
					'separator' => false,
				],

				[
					'text'      => $this->language->get('text_payment'),
					'href'      => $this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'], 'SSL'),
					'separator' => ' :: ',
				],

				[
					'text'      => $this->language->get('text_heading_title'),
					'href'      => $this->url->link('extension/payment/zondacryptopay', 'user_token=' . $this->session->data['user_token'], 'SSL'),
					'separator' => ' :: ',
				],
			],

		];

		$this->response->setOutput($this->load->view('extension/payment/zondacryptopay', $data));
	}

	/**
	 * @return bool
	 */
	protected function validate()
	{
		if(!$this->user->hasPermission('modify', 'extension/payment/zondacryptopay')) {
			$this->error['permission'] = true;

			return false;
		}

        return empty($this->error);
    }
}
