<?php

use ZondacryptoPay\Payment\Util;

/**
 * Class ModelExtensionPaymentZondacryptopay
 */
class ModelExtensionPaymentZondacryptopay extends Model
{
	/**
	 * @param $address
	 * @param $total
	 *
	 * @return array
	 */
	public function getMethod($address, $total)
	{

		$this->load->model('setting/setting');

		include_once(DIR_SYSTEM . 'library/payment-core/vendor/autoload.php');

		$this->language->load('extension/payment/zondacryptopay');
		$order_currency = $this->session->data['currency'];

		if(Util::canUseForCurrency($order_currency)
			&& $this->config->get('payment_zondacryptopay_public_key')
			&& $this->config->get('payment_zondacryptopay_private_key')) {

			return [
				'code'       => 'zondacryptopay',
				'title'      => $this->config->get('payment_zondacryptopay_payment_title')
					?: $this->language->get('text_zondacryptopay_payment_title_default'),
				'terms'      => '',
				'sort_order' => $this->config->get('payment_zondacryptopay_sort_order'),
			];
		}

		return [];
	}
}
