<?php

namespace ZondacryptoPay\Payment;

use Exception;

/**
 * Class Payment
 *
 * Payment main class with all functions to use out of box to implement new payment method.
 *
 * @package Payment
 */
class Payment
{
	/**
	 * Payment constructor.
	 *
	 * @param string $privateKey
	 * @param string $publicKey
	 */
	public function __construct($privateKey, $publicKey)
	{
		Configuration::setPrivateKey($privateKey);
		Configuration::setPublicKey($publicKey);
	}

	/**
	 * @throws Exception
	 */
	public function buildOrder(string $currency, string $orderId, float $price, string $notificationEmail, string $notificationsUrl, string $successUrl, string $failureUrl): PaymentResult
	{
		return ZondacryptoPay::prepareOrderData(Configuration::getPrivateKey(), Configuration::getPublicKey(), $currency, $orderId, $price, $notificationEmail, $notificationsUrl, $successUrl, $failureUrl);
	}
}
